import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M; 
    HSlider SLOPE;
    double MARKER;
    Animator A;
    ListenSquare GO,STOP;

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(0,100,10);	
	 Color[] COL={new Color(0,0,0),Color.white,Color.yellow};
         SLOPE=new HSlider(100,0,1500,30,737,COL,"");
	 MARKER=2; 
	 A=new Animator();
	 GO=new ListenSquare(0,0,40,30);
	 STOP=new ListenSquare(40,0,40,30);
	 GO.on=1;
	 STOP.on=1;
       
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
      RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
      drawGeodesic(g);
      drawMarker(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(Color.black);
	g.fillRect(0,0,getWidth(),getHeight());
	g.setColor(Color.black);
	g.fillRect(10,10,getWidth()-20,getHeight()-20);
	g.setColor(new Color(0,0,120));
	g.drawRect(10,10,getWidth()-20,getHeight()-20);
    }
    public void drawControls(Graphics2D g) {
	SLOPE.render(g);
	GO.render(g,new Color(0,180,0),"go");
	if(A.HALT==false) STOP.render(g,new Color(220,0,0),"stop");
    }

    public void drawGeodesic(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	double s=SLOPE.getValue();

	for(int i=1;i<1600;++i) {
	    gp.reset();
	    double x=4.0*i/1600;
	    double[] p={0,0};
	    p=M.C.getPoint(x);


	    Color C=new Color(255,120,0);
	    Complex z=new Complex(p[0],p[1]);

	    for(int q=0;q<2;++q) {
	    	if(PolygonWrapper.contains(M.C.POLY[q],z)==true) C=M.C.COL[q];
	     }

	    g.setColor(C);
	    x=x*400;
	    gp.moveTo(x,40);
	    gp.lineTo(x,90);
	    gp.lineTo(x+1,90);
	    gp.lineTo(x+1,40);
	    gp.closePath();
	    g.setColor(C);
	    g.fill(gp);
	}
    }

    public void drawPoint(Graphics2D g,Complex z,double r,Color C) {
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<64;++i) {
	    double t=2.0*i*Math.PI/64;
	    double c=z.x+r*Math.cos(t);
	    double s=z.y+r*Math.sin(t);
	    if(i==0) gp.moveTo(c,s);
	    if(i!=0) gp.lineTo(c,s);
	}
	g.setColor(C);
	g.fill(gp);
	g.draw(gp);
    }

    public void drawMarker(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	double x=MARKER;
	Complex z=new Complex(x*400,65);
	drawPoint(g,z,6,Color.yellow);
    }

    public void go() {
	if(A.HALT==false) return;
	A=new Animator(this.M);
        new Thread(A).start();
    }

    public void mousePressed(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	SLOPE.modify(J.X);
	if(J.X.y>35) MARKER=1.0*J.X.x/400;
	if(GO.inside(J.X)==1) go();
	if(STOP.inside(J.X)==1) A.HALT=true;
	repaint();
	M.C.repaint();
    }
     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	SLOPE.modify(J.X);
	if(J.X.y>35) MARKER=1.0*J.X.x/400;
	if(MARKER<.00001) MARKER=.00001;
	if(MARKER>3.9999) MARKER=3.9999;
	repaint();
	M.C.repaint();

     }


}

