import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

/*This class does the basic arithmetic
  of complex numbers */

public class CubeSlicer {


    public static Path2D.Double slice(int D,HSlider[][] NAV) {
	Complex[] LIST=findPoints(D,NAV);
	PolygonWrapper P=new PolygonWrapper(LIST.length,LIST);
	P=PolygonWrapper.convexHull(P);
	Path2D.Double gp=P.toGeneralPath();
	return gp;
    }

    public static Complex[] findPoints(int D,HSlider[][] NAV) {
	double[][] V=CubeMaker.fromNavigator(D,NAV);
	V=CubeMaker.grahamSchmidt(D,V);
	return findPoints(D,V);
    }

    public static Complex[] findPoints(int D,double[][] V) {
	int count=0;
	Complex z=new Complex(0,0);

	Complex[] LIST=new Complex[2*D*(D-1)];
	for(int i=0;i<D;++i) {
	    for(int j=i+1;j<D;++j) {
		for(int k=-1;k<=1;k=k+2) {
		    for(int l=-1;l<=1;l=l+2) {
			LIST[count]=findPoint(D,V,i,j,k,l);
			++count;
		    }
		}
	    }
	}
	return LIST;
    }




    public static Complex findPoint(int D,double[][] V,int i,int j,double c,double d) {
	double v00=V[0][i];
	double v10=V[1][i];
	double v01=V[0][j];
	double v11=V[1][j];

	double det=v00*v11-v10*v01;
	if(det*det<.00000001) return new Complex(0,0);
	double a=(-d*v10+c*v11)/det;
	double b=(+d*v00-c*v01)/det;

	for(int k=0;k<D;++k) {
	    double e=a*V[0][k]+b*V[1][k];
	    if(e*e>1.00001) return new Complex(0,0);
	}
	return new Complex(a,b);
    }


}


    